#include "DAGH.h"
#include "Consts.h"
#include "ADMvar.h"
#include "SArray.h"
#include "TArray.h"
#include "BHmask.h"
#include "Variables.h"
#include "init.h"
#include "input_params.h"
#include "initfortran.h"

int  Stop_Criterion(V &VA, int rank) {

  INTEGER stopnow;
  INTEGER itc;
  INTEGER tdagh=0;
  INTEGER idt=1;
  INTEGER cg;
  DOUBLE p,s;
  DOUBLE g_error,k_error;

  //unpack V

      ADMstensor *g=VA.g;
      ADMstensor *k=VA.k;
      ADMscalar *alpha=VA.alpha;
      ADMvector *beta=VA.beta;
      BHmask *theMask=VA.theMask;
      ADMscalar *obmask=VA.obmask;
      SArray *shift_p=VA.shift_p;
      SArray *shift_po=VA.shift_po;
      TArray *shift_t=VA.shift_t;
      ADMtemp *tmp_pool=VA.tmp_pool;
      DOUBLE *params=VA.params;

  GridFunction(DIM)<DOUBLE> &st = *(*g).spacetime[0];

  if(params[P_MAXLEV]>1.0) {
    cout << "Stop criterion is not yet AMR safe" << endl << flush;
    exit(0);
  } 
  INTEGER Level=0;  

  TMPstensor *g_err = new TMPstensor(tmp_pool);
  TMPstensor *k_err = new TMPstensor(tmp_pool);
  TMPscalar *daghtmp1 = new TMPscalar(tmp_pool);
  TMPscalar *daghtmp2 = new TMPscalar(tmp_pool);
  
  for (itc=0;itc<6;itc++) {
    (*(*g_err).spacetime[itc]).GF_equals(tdagh,Level,*(*g).spacetime[itc],tdagh,Level, DAGH_Main);
    (*(*g_err).spacetime[itc]).GF_minus(tdagh,Level,*(*g).spacetime[itc],tdagh-idt,Level,DAGH_Main);
    (*(*k_err).spacetime[itc]).GF_equals(tdagh,Level,*(*k).spacetime[itc],tdagh,Level, DAGH_Main);
    (*(*k_err).spacetime[itc]).GF_minus(tdagh,Level,*(*k).spacetime[itc],tdagh-idt,Level,DAGH_Main);
     }


    forall(st,tdagh,Level,cg){
      f_fake_mask1(FBA(st(tdagh,Level,cg,DAGH_Main)),
      (*(*theMask).mask)(tdagh,Level,cg,DAGH_Main).data(),
      (*(*daghtmp1).spacetime[0])(tdagh,Level,cg,DAGH_Main).data());
    } end_forall;

    p = (*(*daghtmp1).spacetime[0]).GF_sum(tdagh,Level,DAGH_Main);

   for (itc=0;itc<6;itc++) { 

    forall(st,tdagh,Level,cg){
       f_fake_mask2(FBA(st(tdagh,Level,cg,DAGH_Main)),
       (*(*g_err).spacetime[itc])(tdagh,Level,cg,DAGH_Main).data(),
       (*(*theMask).mask)(tdagh,Level,cg,DAGH_Main).data(),
       (*(*daghtmp2).spacetime[0])(tdagh,Level,cg,DAGH_Main).data());
     } end_forall;

    s = (*(*daghtmp2).spacetime[0]).GF_sum(tdagh,Level,DAGH_Main);

    g_error=s/p; 

    forall(st,tdagh,Level,cg){
       f_fake_mask2(FBA(st(tdagh,Level,cg,DAGH_Main)),
       (*(*k_err).spacetime[itc])(tdagh,Level,cg,DAGH_Main).data(),
       (*(*theMask).mask)(tdagh,Level,cg,DAGH_Main).data(),
       (*(*daghtmp2).spacetime[0])(tdagh,Level,cg,DAGH_Main).data());
     } end_forall;

    s = (*(*daghtmp2).spacetime[0]).GF_sum(tdagh,Level,DAGH_Main);

    k_error=s/p; 
     
    if(rank == 0) cout << itc << " " << g_error << " " << k_error << endl << flush;

    }


  stopnow=0;
  delete daghtmp1;
  delete daghtmp2;
  delete g_err;
  delete k_err;

  //do calculation
  

  return stopnow;
}

